-- Created by NuclearTonic
-- The use of this code requires the permission of the author.
-- Permission can be atained by contacting NuclearTonic at: TonicBars@gmail.com
--
-- RESPECT!

import "Turbine.Gameplay";
import "Turbine.UI";
import "Tonic.Utils.Class";

InventoryManager = class( Turbine.Object  );

function InventoryManager:Constructor()
	self.ADD = 1;
	self.REMOVE = 2;
	
	if ( self.registeredEvents == nil ) then
		self.registeredEvents = { };
	end
	
	self:RegisterForBackpackCallbacks();
	self:Inventory();
end

function InventoryManager:RegisterForEvents( registerant, rid )
	if ( self.clients == nil ) then
		self.clients = { };
	end
	if ( self.clients[rid] == nil ) then
		self.clients[rid] = { };
	end

	self.clients[rid].registered = true;
	self.clients[rid].bar = registerant;

	self:NotifyClients();
end

function InventoryManager:UnregisterForEvents( rid )
	if ( self.clients ~= nil and self.clients[rid] ~= nil ) then
		self.clients[rid].registered = false;
		self.clients[rid].bar = nil;
		self.clients[rid] = nil;
	end
end

function InventoryManager:NotifyClients( specificItem )
	if ( self.clients == nil ) then
		self.clients = { };
	end
	local backpack = player.GetBackpack();
	for key, value in pairs (self.clients) do
		local visible = false;
		local barSettings = theSettingsManager:GetBarSettings( key );
		if ( value ~= nil and value.registered == true and barSettings.events ~= nil and barSettings.events.inventory ~= nil and maitre_d ~= nil and maitre_d:Alive( key ) == true) then
			if ( specificItem == nil ) then
				-- Send all based events to all clients
				for key2, value2 in pairs (barSettings.events.inventory) do
					for i=1, backpack.GetSize(), 1 do 
						local item = backpack.GetItem(i);
						if ( item ~= nil and (item.GetCategory() == value2 or item.GetName() == value or item.GetQuantity <= value2) ) then
							value.bar:AddInventoryItem( item );
						end
					end
				end
			else
				if ( item ~= nil and (item.GetCategory() == value2 or item.GetName() == value or item.GetQuantity <= value2) ) then
					value.bar:AddInventoryItem( item );
				end
			end
		end
	end
end

function InventoryManager:GetRegisteredEvents()
	return self.registeredEvents;
end

function EventManager:RegisterForBackpackCallbacks()
	eventManager.AddCallback( self, player, "ItemAdded", function( sender, args )
		self:NotifyClients( self.ADD, args.item );
	end);
	eventManager.AddCallback( self, player, "ItemRemoved", function( sender, args )
		self:NotifyClients( self.REMOVE, args.item );
	end);
end
